/*
 * UART0.cpp
 *
 *  Created on: 26-10-2015
 *      Author: Wojtek
 */

#include "UART0.h"

void UART0::init() {
//Ustawic predkosc transmisji na 19200
	UBRR0H =;
	UBRR0L =;
	
//Ustawic kanal odbioru i nadawania
	UCSR0B =;
//Ustawic tryb pracy 8bitw, 1bity stopu 
	UCSR0C =;
}

void UART0::enableTxInterrupt() {
	sbi(UCSR0B,TXCIE0);
}
void UART0::enableRxInterrupt() {
	sbi(UCSR0B,RXCIE0);
}

uint8_t UART0::receiveByte(void) // funkcja odbioru bajtu z RS232
		{
	while (!(UCSR0A & (1 << RXC0)))
		;
	return UDR0;
}

int16_t UART0::receiveByteNonBlock(void) {
	if (UCSR0A & (1 << RXC0)) {
		return UDR0;
	} else {
		return -1;
	}
}

int16_t UART0::receiveByteTimeOut(uint8_t timeOut) {
	int16_t komenda = -1;
	for (uint8_t i = 0; i < timeOut; i++) {
		_delay_us(10);
		komenda = receiveByteNonBlock();
		if (komenda != -1) {
			break;
		}
	}
	return komenda;
}

void UART0::sendByte(const uint8_t data) // funkcja wysania bajtu po UART
		{
		//Oczekiwanie az modul bedzie gotowy
	while (!(UCSR0A & (1 << UDRE0)))
		;
		//Wyslac bajt - zmienna data
	UDR0 =;
}

void UART0::sendText(const char * text) {
	while (*text) {
		sendByte(*text++);
	}
}
void UART0::sendByteAsText(const int16_t wartosc) {
	char pom[10];
	sprintf(pom, "%d", wartosc);
	sendText(pom);
}


